
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Audit_eventsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const audit_events = await db.audit_events.create(
            {
                id: data.id || undefined,
        
        event_type: data.event_type
        ||
        null
            ,
            
        entity_name: data.entity_name
        ||
        null
            ,
            
        entity_reference: data.entity_reference
        ||
        null
            ,
            
        event_time: data.event_time
        ||
        null
            ,
            
        ip_address: data.ip_address
        ||
        null
            ,
            
        user_agent: data.user_agent
        ||
        null
            ,
            
        details_json: data.details_json
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await audit_events.setOrganization(currentUser.organization.id || null, {
            transaction,
        });
        
        await audit_events.setActor( data.actor || null, {
            transaction,
        });
        

        

        

        return audit_events;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const audit_eventsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                event_type: item.event_type
            ||
            null
            ,
            
                entity_name: item.entity_name
            ||
            null
            ,
            
                entity_reference: item.entity_reference
            ||
            null
            ,
            
                event_time: item.event_time
            ||
            null
            ,
            
                ip_address: item.ip_address
            ||
            null
            ,
            
                user_agent: item.user_agent
            ||
            null
            ,
            
                details_json: item.details_json
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const audit_events = await db.audit_events.bulkCreate(audit_eventsData, { transaction });

        // For each item created, replace relation files
        

        return audit_events;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const audit_events = await db.audit_events.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.event_type !== undefined) updatePayload.event_type = data.event_type;
        
        
        if (data.entity_name !== undefined) updatePayload.entity_name = data.entity_name;
        
        
        if (data.entity_reference !== undefined) updatePayload.entity_reference = data.entity_reference;
        
        
        if (data.event_time !== undefined) updatePayload.event_time = data.event_time;
        
        
        if (data.ip_address !== undefined) updatePayload.ip_address = data.ip_address;
        
        
        if (data.user_agent !== undefined) updatePayload.user_agent = data.user_agent;
        
        
        if (data.details_json !== undefined) updatePayload.details_json = data.details_json;
        
        
        updatePayload.updatedById = currentUser.id;

        await audit_events.update(updatePayload, {transaction});

        
        
        if (data.organization !== undefined) {
            await audit_events.setOrganization(
              
              (globalAccess ? data.organization : currentUser.organization.id),
              
              { transaction }
            );
        }
        
        if (data.actor !== undefined) {
            await audit_events.setActor(
              
              data.actor,
              
              { transaction }
            );
        }
        

        
        

        

        return audit_events;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const audit_events = await db.audit_events.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of audit_events) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of audit_events) {
                await record.destroy({transaction});
            }
        });


        return audit_events;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const audit_events = await db.audit_events.findByPk(id, options);

        await audit_events.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await audit_events.destroy({
            transaction
        });

        return audit_events;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const audit_events = await db.audit_events.findOne(
            { where },
            { transaction },
        );

        if (!audit_events) {
            return audit_events;
        }

        const output = audit_events.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.organization = await audit_events.getOrganization({
            transaction
        });
        
        
        output.actor = await audit_events.getActor({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.organizations,
        as: 'organization',
        
      },

      {
        model: db.users,
        as: 'actor',
        
        where: filter.actor ? {
          [Op.or]: [
            { id: { [Op.in]: filter.actor.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.actor.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.entity_name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'audit_events',
                        'entity_name',
                        filter.entity_name,
                    ),
                };
            }
            
            if (filter.entity_reference) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'audit_events',
                        'entity_reference',
                        filter.entity_reference,
                    ),
                };
            }
            
            if (filter.ip_address) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'audit_events',
                        'ip_address',
                        filter.ip_address,
                    ),
                };
            }
            
            if (filter.user_agent) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'audit_events',
                        'user_agent',
                        filter.user_agent,
                    ),
                };
            }
            
            if (filter.details_json) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'audit_events',
                        'details_json',
                        filter.details_json,
                    ),
                };
            }
            

            
            

            
            if (filter.event_timeRange) {
                const [start, end] = filter.event_timeRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    event_time: {
                    ...where.event_time,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    event_time: {
                    ...where.event_time,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.event_type) {
                where = {
                    ...where,
                event_type: filter.event_type,
            };
            }
            


      
      if (filter.organization) {
        const listItems = filter.organization.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationId: {[Op.or]: listItems}
        };
      }
      

      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.audit_events.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'audit_events',
                        'entity_reference',
                        query,
                    ),
                ],
            };
        }

        const records = await db.audit_events.findAll({
            attributes: [ 'id', 'entity_reference' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['entity_reference', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.entity_reference,
        }));
    }

    
};

